<?php
/*
 // Events
define('TA','TA'); // New task Assigned
define('TS','TS'); // Task status changed
define('CO','CO'); // Comments
define('AT','AT'); // New attachment
define('TD','TD'); // Task Due Date Changed
define('TT','TT'); // Timsesheet toggle start || stop
define('TU','TU'); // Task updated
define('TR','TR'); // Timsesheet start
define('TO','TO'); // Timsesheet stop
*/

class output_time_notifications {

	public $name	= 'Output Time Notifications';

	public $description	= 'Output Time Notifications addon';

	public $author	= 'Srimax';

	function __construct()
	{
		// parent::__construct();
	}

	public function run($app, $users, $data, $followers, $notify_data)
	{
		// allow only, new Task, comments, attachments.
		if (in_array($app['event_code'], array('TS', 'TD', 'TT', 'TU', 'TR', 'TO')))
		{
			$app['event_code']	= 'TU';
// 			return;
		}

		$message	= $notify_data;

		unset($message['project_id']);
		unset($message['task_id']);

		// if socket can connect then push to node js app.
		// else update in database.
		$data['server_name'] = $app['server_name'];
		if (isset($users[$app['app_id']]))
		{
			$header = array($app['auth_key_name'] . ':' . $app['auth_key_value']);
			foreach ($users[$app['app_id']] as $user_id=>$to_email)
			{
				if (!in_array($user_id, $followers))
					continue;

				$data	= array(
					'entity_id'	=> $app['entity_id'],
					'user_id'	=> $user_id,
					'type'	=> $app['event_code'],
					'message'	=> json_encode($message),
					'count'		=> '1',
					'updated_date'	=> date('Y-m-d H:i:s')
				);

				if (!empty($notify_data['project_id']))
				{
					$data['project_id']	= $notify_data['project_id'];
				}

				if (!empty($notify_data['task_id']))
				{
					$data['task_id']	= $notify_data['task_id'];
				}

				$new_id	= $this->save($data);
// file_put_contents('notify.log', print_R($new_id, true) . PHP_EOL, FILE_APPEND);
			}
		}
	}

	private function pattern_match ($pattern, $content, $data)
	{
		if (preg_match_all($pattern,$content,$matches) && !empty($matches[1]))
		{
			foreach($matches[1] as $key => $val)
			{
				$r_text = isset($data[$val])?$data[$val]:'';
				$content = str_replace($matches[0][$key],$r_text,$content);
			}
		}
		return $content;
	}

	private function save($data=array())
	{
		$CI = get_instance();

		$where	= array(
			'entity_id'	=> $data['entity_id'],
			'user_id'	=> $data['user_id'],
			'type'		=> $data['type'],
			'is_read'	=> '0'
		);
		if (!empty($data['project_id']))
		{
			$where['project_id']	= $data['project_id'];
		}
		if (!empty($data['task_id']))
		{
			$where['task_id']	= $data['task_id'];
		}

		$query	= $CI->db->select('*')->from('notification')->where($where)->get();
		$result	= $query->result_array();

		if (!empty($result))
		{
			$result	= $result[0];
			$data['count']	= $result['count'] + 1;
// 			$message	= json_decode($result['message']);
// 			if ($message && $data['message'])
// 			{
// 				$message
// 			}
			$CI->db->where(array(
				'notification_id'	=> $result['notification_id']
			));
			$CI->db->update('notification', $data);
		}
		else
		{
			$data['created_date']	= date('Y-m-d H:i:s');
			$CI->db->insert('notification', $data);
			return $CI->db->insert_id();
		}
	}
}
