(function($){
	function Gridify(elem, params){
//		"use strict";

		var self	= this;

		params	= params || {};

		self.target	= null;

		self.isShift	= false;
		self.isCtrl	= false;

		self.enterNav	= params.enterNav || "H";
		self.ctrlEnterNav	= params.ctrlEnterNav || "V";

		self.initCell	= params.initCell || 1;

		var _elem	= $("tbody", elem);

		self.isKeyEvent	= params.isKeyEvent == undefined ? true : params.isKeyEvent;

		var grid		= $("#grid-container");
		var viewPort	= $("#view-port", grid);
		var scrollToView	= function(cur){
			var elem	= $(cur);

			if (elem.position().top < grid.scrollTop())
			{
				cur.scrollIntoView();
			}
			else if((elem.position().top + elem.innerHeight()) > (grid.scrollTop() + grid.innerHeight()))
			{
				cur.scrollIntoView(false);
			}
		};

		self.selectedRows	= [];
		var fromIndex	= 0;
		self.setActive	= (function(){
			if (params.freezed && params.freezed.length > 0)
			{
				return function(targ, isClick){
					if (!targ.get(0))
					{
						return;
					}
//					params.onInputEnter && typeof params.onInputEnter == "function" && params.onInputEnter(targ);
					$(".hidder").css({
						left: -999,
						top: -999
					});
					$('#popover').hide();
					$(".hidder > *").hide();

					if (self.isShift)
					{
						var frmIndex	= fromIndex,
							toIndex		= targ.parent().index();
						var diffIndex	= toIndex - frmIndex;

						if (diffIndex < 0)
						{
							toIndex	= [frmIndex, frmIndex=toIndex][0];
							diffIndex	= Math.abs(diffIndex);
						}

						$("tr.active, tr.active td.active", elem).removeClass("active");
						targ.addClass("active");

						self.selectedRows	= [];
						var tmpIndex	= 0;
						for (var i=0; i<=diffIndex; i++)
						{
							tmpIndex	= frmIndex+i+1;
							$("tbody tr:nth-child(" + tmpIndex + ")", $(params.freezed+"")).addClass("active");
							self.selectedRows.push($("tbody tr:nth-child(" + tmpIndex + ") td:nth-child(" + targ.index() + ")", targ.parents("table")));
						}
					}
					else
					{
						$("tr.active, tr.active td.active", elem).removeClass("active");
						self.selectedRows	= null;
						targ.addClass("active");
						fromIndex	= targ.parent().index();
						$("tbody tr:nth-child(" + (fromIndex+1) + ")", $(params.freezed+"")).addClass("active");
					}
					self.target	= targ;
					params.onSelect && typeof params.onSelect == "function" && params.onSelect(self.selectedRows || targ, self.clipBrd, isClick);
				};
			}

			return function(targ, isClick){
				if (!targ.get(0))
				{
					return;
				}
//				params.onInputEnter && typeof params.onInputEnter == "function" && params.onInputEnter(targ);
				$(".hidder").css({
					left: -999,
					top: -999
				});
				$(".hidder > *").hide();
				if (self.isShift)
				{
					$("tr.active td.active", elem).removeClass("active");
				}
				else
				{
					$("tr.active, tr.active td.active", elem).removeClass("active");
					self.selectedRows	= null;
					targ.addClass("active");
					targ.parent().addClass("active");
				}
				self.target	= targ;

				params.onSelect && typeof params.onSelect == "function" && params.onSelect(self.selectedRows || targ, self.clipBrd, isClick);
			};
		})();

		var clickHandler	= function(e){
			var targ	= $(e.target);
			if (!targ.is("td"))
			{
				targ	= targ.parents("td");
			}

			self.setActive(targ, true);
		};

		// KeyEvents

		var clipBrd	= $(".copyPaste");
		if (!clipBrd.get(0))
		{
			clipBrd	= $("<textarea/>");
			var clipBrdDiv	= $("<div/>");
			clipBrdDiv.css({
				position: "absolute",
				top: "-10000px",
				left: "-10000px"
			});
			clipBrdDiv.appendTo($("body"));
			clipBrd.addClass("copyPaste").appendTo(clipBrdDiv);
		}

		self.clipBrd	= clipBrd;

		var keyCodeMap	= {
			8:"backspace", 9:"tab", 13:"return", 16:"fshift", 17:"ctrl", 18:"alt", 19:"pausebreak", 20:"capslock", 27:"escape", 32:" ", 33:"pageup",
			34:"pagedown", 35:"end", 36:"home", 37:"left", 38:"up", 39:"right", 40:"down", 43:"+", 44:"printscreen", 45:"insert", 46:"delete",
			48:"0", 49:"1", 50:"2", 51:"3", 52:"4", 53:"5", 54:"6", 55:"7", 56:"8", 57:"9", 59:";",
			61:"=", 65:"a", 66:"b", 67:"c", 68:"d", 69:"e", 70:"f", 71:"g", 72:"h", 73:"i", 74:"j", 75:"k", 76:"l",
			77:"m", 78:"n", 79:"o", 80:"p", 81:"q", 82:"r", 83:"s", 84:"t", 85:"u", 86:"v", 87:"w", 88:"x", 89:"y", 90:"z",
			96:"0", 97:"1", 98:"2", 99:"3", 100:"4", 101:"5", 102:"6", 103:"7", 104:"8", 105:"9",
			106: "*", 107:"+", 109:"-", 110:".", 111: "/",
			112:"f1", 113:"f2", 114:"f3", 115:"f4", 116:"f5", 117:"f6", 118:"f7", 119:"f8", 120:"f9", 121:"f10", 122:"f11", 123:"f12",
			144:"numlock", 145:"scrolllock", 186:";", 187:"=", 188:",", 189:"-", 190:".", 191:"/", 192:"`", 219:"[", 220:"\\", 221:"]", 222:"'"
		};

		var modifiedByShift	= {
			192:"~", 48:")", 49:"!", 50:"@", 51:"#", 52:"$", 53:"%", 54:"^", 55:"&", 56:"*", 57:"(", 109:"_", 61:"+",
			219:"{", 221:"}", 220:"|", 59:":", 222:"\"", 188:"<", 189:">", 191:"?",
			96:"insert", 97:"end", 98:"down", 99:"pagedown", 100:"left", 102:"right", 103:"home", 104:"up", 105:"pageup"
		};

		var cur	=	null;

		var ctrlKeys	= [];

		ctrlKeys["c"]	= params.ctrlC ? function(e){
			params.ctrlC(e, self.clipBrd);
			self.clipBrd.focus().get(0).select();
			return true;
		} : null;	// Copy
		ctrlKeys["v"]	= params.ctrlV ? function(e){
			self.clipBrd.focus().get(0).select();
			setTimeout(function(){
				params.ctrlV(e, self.clipBrd);
			}, 50);
			return true;
		}: null;	// Paste
		ctrlKeys["s"]	= params.ctrlS;	// Save
		ctrlKeys["z"]	= params.ctrlZ;	// Undo
		ctrlKeys["y"]	= params.ctrlY;	// Redo
		ctrlKeys["n"]	= params.ctrlN;	// New
		ctrlKeys["up"]	= params.ctrlUp ? function(e){
			var tbody	= self.target.parents("tbody");
			var col	= self.target.index();
			var row	= self.target.parent().index()-1;
			if (row<0)
			{
				return true;
			}

			var ret	= params.ctrlUp(e, self.target);
			if (typeof ret === "object" && ret.get(0))
			{
				self.setActive(ret);
				return;
			}
			else if(ret === false)
			{
				return;
			}

			row	= $("tr", tbody).get(row);
			col	= $("td", row).get(col);
			self.setActive($(col));
		} : null;	// Move Up
		ctrlKeys["down"]	= params.ctrlDown ? function(e){
			var tbody	= self.target.parents("tbody");
			var col	= self.target.index();
			var row	= self.target.parent().index()+1;
			if (row > $("tr", tbody).length)
			{
				return true;
			}

			var ret	= params.ctrlDown(e, self.target);
			if (typeof ret === "object" && ret.get(0))
			{
				self.setActive(ret);
				return;
			}
			else if(ret === false)
			{
				return;
			}

			row	= $("tr", tbody).get(row);
			col	= $("td", row).get(col);
			self.setActive($(col));
		} : null;	// Move Down
		ctrlKeys["i"]	= params.ctrlI ? function(e){
			var elem	= "tr:nth-child(" + (self.target.parent().index()+1) + ") td:nth-child(" + (self.target.index()+1) + ")";
			var tbody	= self.target.parents("tbody");
			params.ctrlI(e, self.target);
			self.setActive($(elem, tbody));
		} : null;	// Indent
		ctrlKeys["u"]	= params.ctrlU ? function(e){
			var elem	= "tr:nth-child(" + (self.target.parent().index()+1) + ") td:nth-child(" + (self.target.index()+1) + ")";
			var tbody	= self.target.parents("tbody");
			params.ctrlU(e, self.target);
			self.setActive($(elem, tbody));
		} : null;	// Un-Indent

		ctrlKeys["ctrlInsertB"]	= params.ctrlInsertB ? function(e){
			var elem	= "tr:nth-child(" + (self.target.parent().index()+2) + ") td:nth-child(" + (self.target.index()+1) + ")";
			var tbody	= self.target.parents("tbody");
			params.ctrlInsertB(e);
			self.setActive($(elem, tbody));
		} : null;// Insert Below

		ctrlKeys["ctrlInsertA"]	= params.ctrlInsertA ? function(e){
			var elem	= "tr:nth-child(" + (self.target.parent().index()+1) + ") td:nth-child(" + (self.target.index()+1) + ")";
			var tbody	= self.target.parents("tbody");
			params.ctrlInsertA(e);
			self.setActive($(elem, tbody));
		} : null;// Insert Above

		ctrlKeys["delete"]	= params.ctrlDelete ? function(e){
//			var next	= self.target.parent().next().children().get(self.target.index());
			var next	= self.target.parent().prev().children().get(self.target.index());
			var tbody	= self.target.parents("tbody");
			var first	= "tr:first-child td:nth-child(" + (self.target.index()+1) + ")";
//			if (!next)
//			{
//				next	= self.target.parent().prev().children().get(self.target.index());
//			}

			if (params.ctrlDelete(e) !== false)
			{
				next	= next ? $(next) : $(first, tbody);
				self.setActive(next);
			}
		} : null;// Delete

		ctrlKeys["home"]	= function(e){
			cur	= $("tr:first-child td:nth-child(" + (self.target.index()+1) + ")", self.target.parents("tbody")).get(0);
			cur && self.setActive($(cur));
			params.ctrlHome && typeof params.ctrlHome == "function" && params.ctrlHome(e);
		};

		ctrlKeys["end"]	= function(e){
			cur	= $("tr:last-child td:nth-child(" + (self.target.index()+1) + ")", self.target.parents("tbody")).get(0);
			cur && self.setActive($(cur));
			params.ctrlEnd && typeof params.ctrlEnd == "function" && params.ctrlEnd(e);
		};

		var keys	= [];
		keys["pageup"]	= function(e){
			cur	= $("tr:first-child td:nth-child(" + (self.target.index()+1) + ")", self.target.parents("tbody")).get(0);
			if (cur)
			{
				self.setActive($(cur));
				scrollToView(cur);
//				cur.scrollIntoView();
			}
			params.pageUp && typeof params.pageUp == "function" && params.pageUp(e);
		};

		keys["pagedown"]	= function(e){
			cur	= $("tr:last-child td:nth-child(" + (self.target.index()+1) + ")", self.target.parents("tbody")).get(0);
			if (cur)
			{
				self.setActive($(cur));
				scrollToView(cur);
//				cur.scrollIntoView();
			}
			params.pageDown && typeof params.pageDown == "function" && params.pageDown(e);
		};

		keys["up"]	= function(e){
			cur	= self.target.parent().prev().children().get(self.target.index());
			if (cur)
			{
				self.setActive($(cur));
				scrollToView(cur);
//				cur.scrollIntoView();
			}
			params.up && typeof params.up == "function" && params.up(e);
		};

		keys["down"]	= function(e){
			cur	= self.target.parent().next().children().get(self.target.index());
			if (cur)
			{
				self.setActive($(cur));
				scrollToView(cur);
//				cur.scrollIntoView();
			}
			params.down && typeof params.down == "function" && params.down(e);
		};

		keys["delete"]	= function(e){
			typeof params.onDelete == "function" && params.onDelete(e, self.target);
		};

		keys["backspace"]	= function(e){
			typeof params.onBackSpace == "function" && params.onBackSpace(e, self.target);
		};

		if (params.freezed && params.freezed.length > 0)
		{
			var first_table	= $(params.freezed[0]);
			var last_table	= $(params.freezed[params.freezed.length-1]+":visible");
			var cnt	= 1;
			var getLastTable	= function(){
				last_table	= $(params.freezed[params.freezed.length-cnt]+":visible");
				if (last_table.get(0))
				{
					cnt=1;
				}
				else
				{
					cnt++;
					last_table	=  getLastTable();
				}
				return last_table;
			};

			keys["end"]	= function(e){
				getLastTable();
				var targ	= $("tr:nth-child("+(self.target.parent().index()+1)+") td:last-child", last_table);
				self.currentTable	= last_table;
				self.setActive(targ);
				params.end && typeof params.end == "function" && params.end(e);
			};

			keys["home"]	= function(e){
				var targ	= $("tr:nth-child("+(self.target.parent().index()+1)+") td:first-child", first_table);
				self.currentTable	= first_table;
				self.setActive(targ);
				params.home && typeof params.home == "function" && params.home(e);
			};

			keys["left"]	= function(e){
				cur	= self.target.prev().get(0);
				if (!cur)
				{
					var tbls	= $("table", elem);
					var prev_table	= tbls[tbls.index(self.target.parents("table"))-1];
					if (prev_table)
						cur	= $("tr:nth-child("+(self.target.parent().index()+1)+") td:last-child", prev_table).get(0);
					else
					{
						getLastTable();
						cur	= $("tr:nth-child("+(self.target.parent().index())+") td:last-child", last_table).get(0);
					}
				}
				if (cur)
				{
					self.setActive($(cur));
					scrollToView(cur);
//					cur.scrollIntoView();
				}
				params.left && typeof params.left == "function" && params.left(e);
			};

			keys["tab"]	= keys["right"]	= function(e){
				cur	= self.target.next().get(0);
				if (!cur)
				{
					var skip	= ":first-child";

					if (e.keyCode == 9)	// Tab key
					{
						skip	= ":not([skip='1'])";
					}
					var tbls	= $("table", elem);
					var next_table	= tbls.get(tbls.index(self.target.parents("table"))+1);
					if (next_table)
					{
						cur	= $("tr:nth-child("+(self.target.parent().index()+1)+") td" + skip, next_table).get(0);
					}
					else
					{
						next_table	= tbls.get(0);
						cur	= $("tr:nth-child("+(self.target.parent().index()+2)+") td" + skip, next_table).get(0);
					}
				}
				if (cur)
				{
					self.setActive($(cur));
					scrollToView(cur);
//					cur.scrollIntoView();
				}
				params.right && typeof params.right == "function" && params.right(e);
			};
		}
		else
		{
			keys["end"]	= function(e){
//				cur	= self.target.parent().children().get(-1);
//				cur && self.setActive($(cur));
				cur	= $("td:last-child", self.target.parent()).get(0);
				cur && self.setActive($(cur));
				params.end && typeof params.end == "function" && params.end(e);
			};

			keys["home"]	= function(e){
//				cur	= self.target.parent().children().get(0);
//				cur && self.setActive($(cur));
				cur	= $("td:first-child", self.target.parent()).get(0);
				cur && self.setActive(cur);
				params.home && typeof params.home == "function" && params.home(e);
			};

			keys["left"]	= function(e){
				cur	= self.target.prev().get(0);
				if (!cur)
					cur	= $("td:last-child", self.target.parent().prev()).get(0);
				if (cur)
				{
					self.setActive($(cur));
					scrollToView(cur);
//					cur.scrollIntoView();
				}
				params.left && typeof params.left == "function" && params.left(e);
			};

			keys["tab"]		= keys["right"]	= function(e){
				cur	= self.target.next().get(0);

				if (!cur)
				{
					var skip	= ":first-child";

					if (e.keyCode == 9)	// Tab key
					{
						skip	= ":not([skip='1'])";
					}
					cur	= $("td"+skip, self.target.parent().next()).get(0);
				}

				if (cur)
				{
					self.setActive($(cur));
					scrollToView(cur);
//					cur.scrollIntoView();
				}
				params.right && typeof params.right == "function" && params.right(e);
			};
		}

		keys["escape"]	= function(e){
			params.onEsc && typeof params.onEsc == "function" && params.onEsc(self.target);
			return true;
		};

		ctrlKeys["return"] = keys["return"]	= keys["f2"]	= function(e, word){	// Enter
			params.onEnter && typeof params.onEnter == "function" && params.onEnter(e, self.target, word);
			return true;
		};

		var fnKeys	= {};
		fnKeys["tab"]	= function(e){
			params.onInputEnter && typeof params.onInputEnter == "function" && params.onInputEnter(self.target);
			keys["tab"] && typeof keys["tab"] == "function" && keys["tab"](e);
			return true;
		};
		fnKeys["return"]	= function(e, isNotNextCell){
			params.onInputEnter && typeof params.onInputEnter == "function" && params.onInputEnter(self.target);

			if (!isNotNextCell)
			{
				var key	= self[e.ctrlKey ? "ctrlEnterNav" : "enterNav"] == "H" ? "tab" : "down";
				keys[key] && typeof keys[key] == "function" && keys[key](self.target);
			}

			return true;
		};
		fnKeys["escape"]	= function(e){
			params.onInputEsc && typeof params.onInputEsc == "function" && params.onInputEsc(self.target);
			return true;
		};

		// 96-105 Numberpad numbers
		// 48-57 Symbols Button numbers
		// 65-90 letters
		// 16 - shift
		// 20 - CapsLock
		// 13 - Enter
		// 17 - Control Key
		var editKeys	= [59, 61, 113, 173, 188, 190, 191, 219, 220, 221, 222];
		var isEditableChars	= function(keyCode){
			// letters, numbers, symbol numbers
			if ((keyCode >= 65 && keyCode <= 90) || (keyCode >= 96 && keyCode <= 105) || (keyCode >= 48 && keyCode <= 57) || (editKeys.indexOf(keyCode) >= 0))
			{
				return true;
			}
			return false;
		};

		var func	= null,
			keyCode	= null;

		var RunThis	= function(func, param, word){
			if (func && typeof func == "function")
			{
				func(param, word);

				// if Ctrl+C pressed return true to copy the txtArea content using system event.
				if (func == ctrlKeys["c"] || func == ctrlKeys["v"])
				{
					return true;
				}

				return false;
			}
			return true;
		};

		var keyUpHandler	= function(e){
			self.isShift	= e.shiftKey;
		};
		var keyDownHandler	= function(e){
//console.log("Key Down : ", e.keyCode, " - ", e.which, keyCodeMap[e.which]);
			var targ	= $(e.target);

			self.isShift	= e.shiftKey;

			if (self.isShift && e.which == 9)
			{
				self.isShift	= false;
				return RunThis(keys["left"], e);
			}

			// Check keys in edit mode.
			if (targ.is("input"))
			{
				if (targ.is(".chosen-search input") && e.which==13)
				{
					return true;
				}
//console.log("Caled :- ", params.onInputKeyPress, e.ctrlKey);
				if (params.onInputKeyPress && typeof params.onInputKeyPress == "function")
				{
					return params.onInputKeyPress(e);
				}

				if (e.ctrlKey)
				{
					if(e.which == 83)	// Key S - Save
					{
						RunThis(fnKeys["return"], e, true);// Close the textbox and apply changes.
						return RunThis(ctrlKeys[keyCodeMap[e.which]], e);	// call the Save fn.
					}
					else if (targ.val() == "" && targ.is(".search-field input"))
					{
						// if multi select box then check target is inputbox
						// if inputbox then check keyDown is ctrl + Enter,
						// if ctrl + Enter then apply the values and go to the next cell.
						return RunThis(fnKeys[keyCodeMap[e.which]], e);
					}
					else if (targ.is(".hasTimeEntry"))
					{
						console.log("Save Time Entry");
					}
				}

				// if tab press procceed to next cell.
				// tab - 9, esc - 27, enter - 13
				var noFields	= ".search-field input, .hasTimeEntry";
				if (
					// if input field is not a chosen search or timesheet popup input
					// and key is in array then got to next cell.
					(targ.not(noFields).get(0) && [9, 13, 27].indexOf(e.which) >= 0) ||
					// if input field is chosen multiselect search input &&
					// Key is tab or esc then go to next cell.
					// otherwise continue in edit mode.
					(targ.is(".search-field input") && [9, 27].indexOf(e.which) >= 0)
				){
					return RunThis(fnKeys[keyCodeMap[e.which]], e);
				}

				return true;
			}

			self.target	= self.target || $($("table tbody tr:first-child td:first-child", elem).get(0));
			var keyCode	= e.which || null;
			if (keyCode)
			{
				var word	= "";
				func	= keys[keyCodeMap[keyCode]];
				if (e.ctrlKey)
				{
					if (keyCodeMap[keyCode] == "insert")
						func	= (e.shiftKey) ? ctrlKeys["ctrlInsertA"] : ctrlKeys["ctrlInsertB"];
					else
						func	= ctrlKeys[keyCodeMap[keyCode]];
				}
				else if (isEditableChars(keyCode))
				{
					word	= keyCodeMap[keyCode];
					word	= (word == "f2")?"":word;
					func	= keys["return"];
				}
				if (self.isShift)
				{
					word	= word.toUpperCase();
				}
				return RunThis(func, e, word);
			}

			return true;
		};

		_elem.live("click", clickHandler);
		$(elem).unbind("keydown").keydown(keyDownHandler);
		$(elem).unbind("keyup").keyup(keyUpHandler);
		_elem.live("dblclick", function(e){
			return RunThis(keys["return"], e);
		});

		self.setSelected	= function(){
			if (!$("tr.active", elem).get(0))
			{
				var tmp	= $("table:first tbody tr:first td", elem).get(self.initCell-1);
				if (tmp)
				{
					self.setActive($(tmp), false);
				}
				else
				{
					self.setActive($("table:first tbody tr:first td:first", elem), false);
				}
			}
		};

		self.trigger	= function(shortCut){
			ctrlKeys[shortCut] && ctrlKeys[shortCut]();
		};

//		self.remove	= function(){
//			_elem.unbind("click", clickHandler);
//			$(document).unbind("keypress", keyDownHandler);
//		};

		if (params.contextmenu && params.contextmenu.elem)
		{
			$(params.contextmenu.elem).unbind("contextmenu").bind("contextmenu", function(e){
				if (!$(e.target).is("input, select"))
				{
					self.setActive($(e.target).closest("td"));
					return params.contextmenu.callback && params.contextmenu.callback(e);
				}
			});
		}

		self.getNextRow	= function(target){
			target	= (target && target.get(0)) ? target : self.target;
			if (!target)
			{
				self.target	= $($("table tbody tr:first-child td:first-child", elem).get(0));
				self.target.addClass("active").parent().addClass("active");
				target	= self.target;
			}
			return target.parent().next();
		};

		self.getNextColumn	= function(target){
			target	= (target && target.get(0)) ? target : self.target;
			if (!self.target)
			{
				self.target	= $($("table tbody tr:first-child td:first-child", elem).get(0));
				self.target.addClass("active").parent().addClass("active");
				target	= self.target;
			}
			var col	= target.next();
			if (!col.get(0))
			{
				var tbls	= $("table", elem);
				var next_table	= tbls.get(tbls.index(target.parents("table"))+1);
				if (next_table)
					col	= $("tr:nth-child("+(target.parent().index()+1)+") td:first-child", next_table);
				else
				{
					next_table	= tbls.get(0);
					col	= $("tr:nth-child("+(target.parent().index()+2)+") td:first-child", next_table);
				}
			}

			return col;
		};

		return self;
	}

	$.fn.gridify	= function(options){
		options.scope	= new Gridify(this, options);
		$(this).data('_gridify', options.scope);
		return this;
	};
})(jQuery);
