﻿(function(Otime){

	Otime.TimeSheetRevoke	= new function(){
//		"use strict";

		var _this	= this;

		_this.name	= "timesheet";

		_this.model	= "TimesheetRevokeModel";

		_this.language	= null;

		_this.users	= [];
		_this.usersObj	= {};

		_this.user_id	= 0;

		_this.TimesheetRevokeModel	= function(data){
			var self	= this;

			data	= data || {};

			self._info	= {};

			$.each(_this.users, function(key, val){
				_this.usersObj[val.user_id]= val;
			});

			self.today	= new Date();

			self.current_date	= Otime.o(self.today);
			self.timesheetdays	= Otime.o(data.days || 0);
			self.days	= Otime.o({});
			self.items	= Otime.a([]);

			self.show_nodata	= Otime.o(false);

			self.users		= Otime.a(_this.users || []);
			self.user_id		= Otime.o(data.user_id || 0);
			self.first_name		= Otime.o(data.first_name || "");
			self.last_name		= Otime.o(data.last_name || "");
			self.user_image		= Otime.o(data.user_image);

			self.projects	= Otime.a([]);
			self.sel_projects	= Otime.o(["0"]);

			var ret		= false, oldVal	= [];
			self.sel_projects.subscribe(function(oldValue){
				oldVal	= oldValue;
			}, null, "beforeChange");
			self.sel_projects.subscribe(function(newVal){
				if (ret)
				{
					ret	= false;
					self.loadInfo();
					return true;
				}
				if (newVal.length <= 0)
				{
					ret	= true;
					self.sel_projects(["0"]);
					return true;
				}
				if (Number(newVal[0]) <= 0)
				{
					ret	= true;
					if (oldVal.length==1 && newVal.length == 2)
					{
						newVal.splice(Number(oldVal[0] == newVal[1]), 1);
						self.sel_projects(newVal);
						return true;
					}
					self.sel_projects(["0"]);
					return true;
				}
				self.loadInfo();
			});

			self.sel_users	= Otime.o(_this.user_id || _this.users[0].user_id || 0);
			self.sel_users.subscribe(function(newVal){
				var _user	= _this.usersObj[newVal];
				self.user_id(_user.user_id);
				self.first_name(_user.first_name);
				self.last_name(_user.last_name);

				self.loadInfo();
			});

			self.usersChosenTmpl	= function(text, templateData){
				console.log(text, templateData);
				return text;
			};

			self.swap_view	= function(){
				Otime.Menu.loadURL("timesheet/approve");
			};

			self._info.current_date	= Otime.o(null);

			self.from_date	= Otime.o();
			self.from_date.subscribe(function(newVal){
				self._info.current_date(newVal);
			});
			self.from_date(Otime.Date(data.from_date));
			self.to_date	= Otime.o(Otime.Date(data.to_date));

			self.tot_week_hours	= Otime.o("");

			var dt	= self.from_date(); // new Date();
			self._info.from_date	= Otime.o(dt.getWeekStart());
			self._info.to_date	= Otime.o(dt.getWeekEnd());
			self._info.nth_week	= Otime.o(dt.getNthWeek());

			self._info.current_date.subscribe(function(newVal){
				newVal	= new Date(newVal);
				self._info.from_date(newVal.getWeekStart());
				self._info.to_date(newVal.getWeekEnd());
				// var nth	= newVal.getNthWeek();
				// self._info.nth_week(nth + "<sup>" + (["st", "nd", "rd"][nth-1] || "th") + "</sup>");
				self._info.nth_week(newVal.getNthWeek());
				self.loadTimeInfo();
			});

			var toolTipTmplD	=  "Approved By\t: ##APPROVED_BY##.\n";
				toolTipTmplD	+= "Approved On\t: ##APPROVED_DATE##.";
			self.getToolTipD	= function(item){
//				if (!item.is_approved() || !item.hours())
//				{
//					return false;
//				}

				var _tmpl	= toolTipTmplD + "";
				_tmpl	= _tmpl.replace('##APPROVED_BY##', Object.values(item.approved_by()).join(",\n\t\t\t\t: "));
				_tmpl	= _tmpl.replace('##APPROVED_DATE##', item.approved_date());

				return _tmpl;
			};

			var prepare_data	= function(flag){
				var post_data	= {};

				if (Number(self.sel_projects()[0]))
					post_data.project_id	= self.sel_projects();

				post_data.user_id	= self.user_id();

				if (!flag)
				{
					post_data.from_date	= self._info.from_date().format(Otime.sqlDateFormat);
					post_data.to_date	= self._info.to_date().format(Otime.sqlDateFormat);
				}

				return post_data;
			};

			self.loadInfo	= function(){
				self.show_nodata(false);
				Otime.app.loadData(new Otime.ContextModel('approved_timesheets', prepare_data(true), function(context){
					var data	= context.response || {};

					if (data.approvable_users != undefined && Object.keys(data.approvable_users).length==2 && data.approvable_users.otvalues.length > 0)
					{
						data.approvable_users	= data.approvable_users.otvalues.setKeys(data.approvable_users.otkeys, null, "user_id");
						_this.approvableUsers	= data.approvable_users;
					}

					if (data.items != undefined)
					{
						if(data.items.user_image)
						{
							data.items.user_image	= Otime.UMIP + data.items.user_image;
						}
						else
						{
							data.items.user_image	= Otime.baseUrl + 'assets/img/no_Img_32.png';
						}

						self.user_image(data.items.user_image);
						self.timesheetdays(data.items.days);
						self.to_date(Otime.Date(data.items.to_date));
						self.from_date(Otime.Date(data.items.from_date));

//						self.loadTimeInfo();
					}
				}));
			};

			self.loadTimeInfo	= function(){
				var data	= prepare_data();

				Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/" + _this.name +'/user_approved_timesheet', data, function(cont){
					var resp	= cont.response || {};

					var days	= {};
					var tmpDate	= new Date(self._info.from_date());

					for (var i=0; i<7; i++)
					{
						days[tmpDate.format(Otime.sqlDateFormat)]	= new _this.DayModel({
							date: tmpDate,
							hours: 0
						});
						tmpDate	= tmpDate.addDays(1);
					}

					var key	= "",
						rows	= {},
						total_hours	= 0;
					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0)
					{
						var tmpObj	= null;
						resp.items	= resp.items.otvalues.setKeys(resp.items.otkeys, function(itm){
							itm.hours	= (itm.hours-0).toFixed(2)-0;
							days[itm.entry_date].hours((days[itm.entry_date].hours() + itm.hours).toFixed(2)-0);

							tmpObj	= days[itm.entry_date].approved_by();
							tmpObj[itm.approved_by]	= tmpObj[itm.approved_by] || (_this.approvableUsers[itm.approved_by] || {}).first_name || "";
							days[itm.entry_date].approved_by(tmpObj);
							days[itm.entry_date].approved_date(Otime.Date(itm.approved_date).format(Otime.dateFormat));

							key	= itm.project_id + "_" + itm.task_type_id + "_" + itm.project_task_name.hashCode();

							if (rows[key])
							{
								var tmp	= rows[key].hours_list();

								if (tmp[itm.entry_date])
								{
									tmp[itm.entry_date]	+= itm.hours;
								}
								else
								{
									tmp[itm.entry_date]	= itm.hours;
								}
								rows[key].hours_list(tmp);
								rows[key].total_hours(rows[key].total_hours() + itm.hours);
							}
							else
							{
								rows[key]	= new _this.TimeContentModel(itm);
							}

							total_hours	+= itm.hours;
						});
					}

					self.days(days);

					self.tot_week_hours(total_hours.toFixed(2));
					self.items(Object.values(rows));
					self.show_nodata(true);
				}), true);
				return true;
			};

			var isPresent	= false;
			self.prev	= function(item){
				isPresent	= true;
				item._info.current_date(new Date(item._info.current_date()).addDays(-7));
			};

			self.next	= function(item){
				isPresent	= true;
				item._info.current_date(new Date(item._info.current_date()).addDays(7));
			};

			self.revoke_week	= function(item){
				var url	= Otime.siteUrl + "/" + _this.name +'/revoke_timesheet';
				var post_data	= prepare_data();

				Otime.app.postData(new Otime.ContextModel(url, post_data, function(cont){
					var resp	= cont.response.user_data;
					item._info.current_date(new Date(item._info.current_date()).addDays(7));
//					item.to_date(Otime.Date(resp.to_date));
//					item.from_date(Otime.Date(resp.from_date));
				}), true);
				return true;
			};

			self.revokeDayEntry	= function(item){
				var url	= Otime.siteUrl + "/" + _this.name +'/revoke_timesheet';
				var post_data	= prepare_data(true);
				post_data.from_date	= item.entry_date
				Otime.app.postData(new Otime.ContextModel(url, post_data, function(cont){
					var resp	= cont.response.user_data;
					self.timesheetdays(resp.days-0);
					self.loadTimeInfo();
//					self.to_date(Otime.Date(resp.to_date));
//					self.from_date(Otime.Date(resp.from_date));
				}), true);
				return true;
			};
		};

		_this.DayModel	= function(data){
			var self	= this;

			data	= data || {};

			self.date		= Otime.o(data.date || new Date());
			self.day_name	= Otime.o(self.date().format("DDD"));
			self.day_value	= Otime.o(self.date().format("DD"));
			self.hours		= Otime.o(data.hours-0);
			self.is_current	= Otime.o(self.date().isToday());
			self.is_leave	= Otime.o(self.date().isLeave());
			self.approved_by	= Otime.o(data.approved_by || {});
			self.approved_date	= Otime.o(data.approved_date);

			self.entry_date	= self.date().format(Otime.sqlDateFormat);
		};

		_this.TimeContentModel	= function(data){
			var self	= this;

			data	= data || {};

			self.project_code	= Otime.o(data.project_code || "");
			self.project_name	= Otime.o(data.project_name || "");
			self.task_type_name	= Otime.o(data.task_type_name || "");
			self.project_task_name	= Otime.o(data.project_task_name || "");
			self.timesheet_hours	= Otime.o(data.hours-0 || 0);
			self.entry_date		= Otime.o(data.entry_date || "");

			self.total_hours	= Otime.o(data.hours-0 || 0);

			var lst		= {};
			lst[self.entry_date()]	= data.hours-0;
			self.hours_list		= Otime.o(lst);
		};

		_this.init	= function(){
			_this.list_container	= $("#tsr-container");

			Otime.unbind();
			
			_this.appModel	= new _this.TimesheetRevokeModel();

			Otime.app.model	= _this.appModel;

			ko.applyBindings(_this.appModel, _this.list_container.get(0));
		
//			_this.appModel.loadInfo();
		};
	};
}(window.Otime));
